#!/bin/bash

HOST='mydomain.com';
PREFIX_SERVER='server';
URL="$HOST/something/"
DOMAIN="mydomain.com"
LIST_URL="mydomain.com/
mydomain.com/something1/
mydomain.com/something2/"


get_ip() 
{
	for i in ` seq -w 01 20 `; do 

	IP=`host $PREFIX_SERVER$i.$DOMAIN | awk '/has address/ { print $4 }'`
	if [ $IP ]; then
		echo "Get ip for $PREFIX_SERVER$i == $IP"
	fi
	done
}

test_url() 
{
	echo "Test de $URL"
	echo ""
	for i in ` seq -w 01 20 `; do 
	IP=`host $PREFIX_SERVER$i.$DOMAIN | awk '/has address/ { print $4 }'`
	if [ $IP ]; then
		echo "$PREFIX_SERVER$i"
		curl -s -I --resolve $HOST:80:$IP $URL
	fi

	done | grep "${PREFIX_SERVER}\|HTTP/1.1"
}

test_url_list() 
{
	echo "$LIST_URL" > list_url.txt

	while read ligne  
	do  
		echo == $ligne
	  	curl -sL -o /dev/null -w "%{http_code}\n" $ligne 
	  	curl -s -I $ligne | grep -v Access | grep Age: 
	  echo ""
	done < list_url.txt
	rm list_url.txt;
}

get_http_code_response() {
	echo "$LIST_URL" > list_url.txt
	cat list_url.txt | xargs -n1 -i curl -o /dev/null -w "%{url_effective}\n%{http_code}\n%{time_total} \n\n" -s {}
	rm list_url.txt;
}

read -n 1 -p "Action to do
[1] get IP of server
[2] test url on several server
[3] test list of url
[4] Get http code response and time for list of url
" choice
echo "";
case "$choice" in 
    1)
		get_ip
	;;
    2)
		test_url

	;;
    3)
		test_url_list

	;;
    4)
		get_http_code_response

	;;
esac

